// -*- C++ -*-
//
//  This file is part of Siena, a wide-area event notification system.
//  See http://www.inf.usi.ch/carzaniga/siena/
//
//  Authors: Antonio Carzaniga
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2002 University of Colorado
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
//  USA, or send email to one of the authors.
//
//
// $Id: bitcounter.h,v 1.4 2010-03-11 15:16:38 carzanig Exp $
//
#ifndef SIENA_BITCOUNTER_H
#define SIENA_BITCOUNTER_H

namespace siena {

extern const unsigned char	BitCounterMap [];
const unsigned char		BitCounterMapMask = 255;
const unsigned char		BitCounterMapShift = 8;

template <class T>
unsigned char bit_count(T x) {
    register unsigned char res = 0;
    while(x) {
	res += BitCounterMap[reinterpret_cast<unsigned char>(x & BitCounterMapMask)];
	x >>= BitCounterMapShift;
    }
    return res;
}

} // end namespace siena

#endif
