#!/bin/sh
#
#  This file is part of Siena, a wide-area event notification system.
#  See http://www.inf.usi.ch/carzaniga/siena/
#
#  Author: Antonio Carzaniga
#  See the file AUTHORS for full details. 
#
#  Copyright (C) 2005  Antonio Carzaniga
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
#  USA, or send email to one of the authors.
#
#
# $Id: bloom_encoding.sh,v 1.5 2010-03-11 15:16:46 carzanig Exp $
#
. $srcdir/config.sh
#
cleanup_files='bloom_encoding.out bloom_encoding.good'
#
$SFF -f b $srcdir/misc.inp > bloom_encoding.good
for algo in s c v B Z X ; do
    if $SFF -f $algo < /dev/null; then
	test_description "Testing Bloom-encoding algorithm '$algo' against naive algorithm..."
	$SFF -f $algo $srcdir/misc.inp > bloom_encoding.out
	if diff bloom_encoding.out bloom_encoding.good; then
	    test_passed_continue
	else
	    test_failed 'see misc.inp, bloom_encoding.out, and bloom_encoding.good for detail'
	fi
    else
	test_description "Skipping Bloom-encoding algorithm '$algo' (not available)..."
	test_passed_continue
    fi
done
cleanup
exit 0
