// -*-C++-*-
//
//  This file is part of Siena, a wide-area event notification system.
//  See http://www.inf.usi.ch/carzaniga/siena/
//
//  Author: Antonio Carzaniga
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 1998-2003 University of Colorado
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
//  USA, or send email to one of the authors.
//
//
// $Id: yysff.h,v 1.18 2010-03-11 15:16:43 carzanig Exp $
//
#ifndef _YYSFF_H
#define _YYSFF_H

#include "config.h"

enum sff_output_level_t {
     SFF_SILENT = 0,
     SFF_MATCH_COUNT = 1,
     SFF_VERBOSE = 2,
};
      
extern int	sff_scanner_open(const char * fname) throw();
extern int	sff_scanner_close() throw();
extern int	sff_parser_stats_only() throw();
extern int	sff_parser_run() throw();
extern void	sff_parser_output_off() throw();
extern void	sff_parser_output_on() throw();
extern void	sff_parser_output_level(sff_output_level_t l) throw();
extern void	sff_parser_clear_statistics() throw();
extern void	sff_parser_print_statistics(const char * frmt = 0) throw();
extern void	sff_parser_set_statistics_format(const char * frmt) throw();
extern void	sff_parser_set_ifconfig_ranges(const char * ranges) throw();
extern int	sff_parser_open_output(const char * filename = 0) throw();
extern void	sff_parser_close_output() throw();
extern void	sff_parser_timer_start() throw();
extern void	sff_parser_timer_stop() throw();
#ifdef HAVE_CUDD
extern void	sff_parser_use_bddbtable() throw();
extern void	sff_parser_use_zddbtable() throw();
#endif
extern void	sff_parser_use_btable() throw();
extern void	sff_parser_use_sorted_btable() throw();
extern void	sff_parser_use_bxtable() throw();
extern void	sff_parser_use_bctable() throw();
extern void	sff_parser_use_bvtable() throw();
extern void	sff_parser_use_fwdtable() throw();
extern void	sff_parser_shutdown() throw();
#endif
